﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Xml;

namespace eSignAnyWhere_SampleCode_SOAP
{
    class SignAnywhereEnvelopeStatus
    {
        /*
<envelopeStatus>
	<id>ec649ae4-b10c-4294-986c-73d010e2e446</id>
    <bulk>5b69258c-2327-43ba-80ad-53b4b6a2f3eb</bulk> <!-- 3.1: in case of a bulk envelope, and if the status was requested for a subenvelope, the envelope id of the parent envelope is returned here -->
	<name>API-Test</name>
	<status>Completed</status> <!-- Draft, Started, InProgress, Canceled, Completed,  Expired,  Rejected, Template, BulkPartlyCompleted, BulkCompleted -->
	<sendDate>2016-04-06T15:15:34.147Z</sendDate>
	<expirationDate>2016-04-08T15:15:34.147Z</expirationDate>
    <metaData>some value</metaData>
	<bulkRecipients>
		<bulkRecipient eMail=\"\" id="">   <!-- in case of a bulk envelope, the email of the bulk recipient is shown in this attribute ... for an envelope with 2 bulk recipients, the bulkrecipients will be present twice-->
			<status>Completed</status>  <!-- Started, InProgress, Canceled, Completed,  Expired,  Rejected -->
			<recipients>
				<recipient>
                    <id>b81488f0-3ab7-44de-b2b1-3a936173d6fc</id>
					<orderIndex>1</orderIndex>
                    <firstName>First</firstName>
					<lastName>Signer</lastName>
					<eMail>signer1@somewhere.com</eMail>
					<status>Signed</status>
					<signedDate>2016-04-06T15:26:55.863Z</signedDate>
					<recipientType>Signer</recipientType>
                    <workstepRedirectionUrl/>
				</recipient>
				<recipient>
                    <id>b81488f0-3ab7-44de-b2b1-3a936173d6fc</id>
					<orderIndex>2</orderIndex>
                    <firstName>First</firstName>
					<lastName>Signer</lastName>
					<eMail>signer2@somewhere.com</eMail>
					<status>NotSigned</status>					
					<recipientType>Signer</recipientType>
                    <workstepRedirectionUrl>http://172.16.17.166/Flow/workstepredirector/sign?identifier=f01dc4b2-7700-4547-9a5a-f1249aee1be6</workstepRedirectionUrl>
                    <workstepConfiguration> ... </workstepConfiguration>
				</recipient>
			</recipients>
			<completedDocuments>
				<logDocumentId>f604a805-dc68-4992-8f55-cf1a2d3c4830</logDocumentId>                
                <logXmlDocumentId>8c574c01-f137-42d2-ab49-5277b897f207</logXmlDocumentId>
				<completedDocument>
					<documentId>c5889751-2991-418b-a894-4c6b9022de95</documentId>
                    <!-- new with v2.6, if enabled in the organization settings, a seperated log per document can be downloaded -->
                    <logDocumentId>447be17a-88d3-4f06-bad6-6e203fe948a0</logDocumentId>
					<fileName>Demo_Contract_Form.pdf</fileName>
					<fields>
						<formField name="textField1">MyText</Field>
					</fields>
         * 			<attachments>
						<attachment>
							<fileName>Reisepass.jpg</fileName>
							<documentId>3073307d-f5c0-4500-9d03-25a9de881e2c</documentId>
						</attachment>
						<attachment>
							<fileName>picture.jpg</fileName>
							<documentId>57fc0b09-0c50-4e4e-8cd2-a341218c3a95</documentId>
						</attachment>
					</attachments>
				</completedDocument>
			</completedDocuments>
		</bulkRecipient>
	</bulkRecipients>
    <documents>
        <document>
          <fileName>Demo_Contract_Form.pdf</fileName>
          <docRefNumber>1</docRefNumber>
          <fields>
            <formField name="Text1">
              <value />
            </formField>
			....
          </fields>
          <pages>
            <page>
              <width>595.31999999999994</width>
              <height>841.92</height>
            </page>
			...
          </pages>
        </document>
    </documents>
</envelopeStatus>
           */

        public string Name;
        public string Id;
        public string BulkId;

        public string EnvelopeStatus;
        public DateTime ExpirationDate;
        public DateTime SendDate;
        
        public string MetaData;
        public List<EnvelopeDocumentInfo> EnvelopeDocuments = new List<EnvelopeDocumentInfo>();       

        public List<SubEnvelope> SubEnvelopes = new List<SubEnvelope>();

        public static SignAnywhereEnvelopeStatus FromXmlElem(XmlElement xmlElem) {
            SignAnywhereEnvelopeStatus envStatus = new SignAnywhereEnvelopeStatus();
            if (xmlElem != null & xmlElem.Name == "envelopeStatus")
            {
                envStatus.Name = ((XmlElement)xmlElem.SelectSingleNode("name")).InnerText;
                envStatus.EnvelopeStatus = ((XmlElement)xmlElem.SelectSingleNode("status")).InnerText;
                envStatus.Id = ((XmlElement)xmlElem.SelectSingleNode("id")).InnerText;
                envStatus.BulkId = ((XmlElement)xmlElem.SelectSingleNode("bulk")).InnerText;

                envStatus.ExpirationDate =  String.IsNullOrWhiteSpace(xmlElem.SelectSingleNode("expirationDate").InnerText)? DateTime.MinValue : XmlConvert.ToDateTime(((XmlElement)xmlElem.SelectSingleNode("expirationDate")).InnerText, XmlDateTimeSerializationMode.Utc);
                envStatus.SendDate =  String.IsNullOrWhiteSpace(xmlElem.SelectSingleNode("sendDate").InnerText)? DateTime.MaxValue : XmlConvert.ToDateTime(((XmlElement)xmlElem.SelectSingleNode("sendDate")).InnerText, XmlDateTimeSerializationMode.Utc);
               XmlElement metaDataNode = (XmlElement)xmlElem.SelectSingleNode("metaData");
               if (metaDataNode != null) {
                envStatus.MetaData = metaDataNode.InnerText;
               }

               if (xmlElem.SelectSingleNode("bulkRecipients") != null)
               {
                   XmlNodeList recipientNodes = xmlElem.SelectSingleNode("bulkRecipients").SelectNodes("bulkRecipient");
                   if (recipientNodes != null)
                   {
                       for (int i = 0; i < recipientNodes.Count; i++)
                       {
                           envStatus.SubEnvelopes.Add(SubEnvelope.FromXmlElement((XmlElement)recipientNodes[i]));
                       }
                   }
               }
                if (xmlElem.SelectSingleNode("documents") != null)
                {
                    XmlNodeList documentNodes = xmlElem.SelectSingleNode("documents").SelectNodes("document");
                    if (documentNodes != null)
                    {
                        for (int i = 0; i < documentNodes.Count; i++)
                        {
                            envStatus.EnvelopeDocuments.Add(EnvelopeDocumentInfo.FromXmlElement((XmlElement)documentNodes[i]));
                        }
                    }
                }

            }
            return envStatus;
        }

        public class SubEnvelope {
            public string RecipientEmail;
            public string SubEnvelopeId;
            public string Status;
            public Documents FinishedDocuments;
            public List<Recipient> Recipients = new List<Recipient>();
          

            public static SubEnvelope FromXmlElement(XmlElement subEnvelopeElem) {
                SubEnvelope subEnv = new SubEnvelope();
                if (subEnvelopeElem != null) {
                    subEnv.RecipientEmail = subEnvelopeElem.GetAttribute("eMail");
                    subEnv.SubEnvelopeId = subEnvelopeElem.GetAttribute("id"); 
                    subEnv.Status = subEnvelopeElem.SelectSingleNode("status").InnerText;
                    subEnv.FinishedDocuments = Documents.FromXmlElement((XmlElement)subEnvelopeElem.SelectSingleNode("completedDocuments"));
                    
                    XmlNodeList recipientsList = ((XmlElement)subEnvelopeElem.SelectSingleNode("recipients")).SelectNodes("recipient");                    
                    for (int r = 0; r < recipientsList.Count; r++)
                    {
                        subEnv.Recipients.Add(Recipient.FromXmlElement((XmlElement)recipientsList[r]));
                    }
                }

                return subEnv;
            }
        }

        public class FormFields
        {

            public List<KeyValuePair<string, string>> FormFieldValues;

            public static FormFields FromXmlElement(XmlElement formFieldsNode)
            {
                FormFields ff = new FormFields();
                ff.FormFieldValues = new List<KeyValuePair<string, string>>();

                if (formFieldsNode != null && formFieldsNode.HasChildNodes)
                {
                    XmlNodeList formFieldsList = formFieldsNode.SelectNodes("formField");
                    if (formFieldsList != null && formFieldsList.Count > 0)
                    {
                        for (int f = 0; f < formFieldsList.Count; f++)
                        {
                            ff.FormFieldValues.Add(new KeyValuePair<string, string>(((XmlElement)formFieldsList[f]).GetAttribute("name"), ((XmlElement)formFieldsList[f]).InnerText));
                        }
                    }
                }
                return ff;
            }
        }


        public class PageInfo {
            public double WidthInPoints;
            public double HeightInPoints;

            public static PageInfo FromXmlElement(XmlElement pageNode) {
                PageInfo pi = new PageInfo();

                pi.WidthInPoints = XmlConvert.ToDouble(pageNode.SelectSingleNode("width").InnerText);
                pi.HeightInPoints = XmlConvert.ToDouble(pageNode.SelectSingleNode("height").InnerText);

                return pi;
            }
        
        }


        public class EnvelopeDocumentInfo
        {
           /*
             <documents>
                <document>
                  <fileName>Demo_Contract_Form.pdf</fileName>
                  <docRefNumber>1</docRefNumber>
                  <fields>
                    <formField name="Text1">
                      <value />
                    </formField>
			        ....
                  </fields>
                  <pages>
                    <page>
                      <width>595.31999999999994</width>
                      <height>841.92</height>
                    </page>
			        ...
                  </pages>
                </document>
            </documents>
             */


            public string DocumentName;
            public FormFields FormFieldValues;
            public int WorkstepDocRefNumber;
            public List<PageInfo> Pages = new List<PageInfo>();

            public static EnvelopeDocumentInfo FromXmlElement(XmlElement docInfoNode)
            {
                EnvelopeDocumentInfo envDocInfo = new EnvelopeDocumentInfo();
                envDocInfo.DocumentName = ((XmlElement)docInfoNode.SelectSingleNode("fileName")).InnerText;
                envDocInfo.WorkstepDocRefNumber = XmlConvert.ToInt32(docInfoNode.SelectSingleNode("docRefNumber").InnerText);

                envDocInfo.FormFieldValues = FormFields.FromXmlElement((XmlElement)docInfoNode.SelectSingleNode("fields"));            

                XmlNode pagesNode = docInfoNode.SelectSingleNode("pages");
                if (pagesNode != null)
                {
                    XmlNodeList pagesNodeList =  pagesNode.SelectNodes("page");
                    if (pagesNodeList != null) {
                        for (int p = 0; p < pagesNodeList.Count; p++)
                        {
                            envDocInfo.Pages.Add(PageInfo.FromXmlElement((XmlElement)pagesNodeList[p]));
                        }                    
                    }
                }

                return envDocInfo;
            }
        }

        public class Documents {

            public List<CompletedDocumentInfo> DocumentList = new List<CompletedDocumentInfo>();
            public string LogDocId;
            //new with version 2.6: an abstract xml about the envelope log can be downloaded
            public string LogXmlDocId;

            public static Documents FromXmlElement(XmlElement completedDocumentsElem)
            {
                
                Documents completedDocs = new Documents();
                
                if (completedDocumentsElem != null && completedDocumentsElem.HasChildNodes)
                {
                    completedDocs.LogDocId = ((XmlElement)completedDocumentsElem.SelectSingleNode("logDocumentId")).InnerText;
                    completedDocs.LogXmlDocId = ((XmlElement)completedDocumentsElem.SelectSingleNode("logXmlDocumentId")).InnerText;

                    XmlNodeList completedDocsElemList = completedDocumentsElem.SelectNodes("completedDocument");
                    if (completedDocsElemList != null)
                    {
                        for (int i = 0; i < completedDocsElemList.Count; i++)
                        {
                            completedDocs.DocumentList.Add(CompletedDocumentInfo.FromXmlElement((XmlElement)completedDocsElemList[i]));
                        }
                    }
                }

                return completedDocs;
            }

/*
                <completedDocument>
					<documentId>c5889751-2991-418b-a894-4c6b9022de95</documentId>
                    <!-- new with v2.6, if enabled in the organization settings, a seperated log per document can be downloaded -->
                    <logDocumentId>447be17a-88d3-4f06-bad6-6e203fe948a0</logDocumentId>
					<fileName>Demo_Contract_Form.pdf</fileName>
					<fields>
						<formField name="textField1">MyText</Field>
					</fields>
          			<attachments>
						<attachment>
							<fileName>Reisepass.jpg</fileName>
							<documentId>3073307d-f5c0-4500-9d03-25a9de881e2c</documentId>
						</attachment>
						<attachment>
							<fileName>picture.jpg</fileName>
							<documentId>57fc0b09-0c50-4e4e-8cd2-a341218c3a95</documentId>
						</attachment>
					</attachments>
				</completedDocument>
 */


            public class CompletedDocumentInfo
            {
                public string DocumentId;
                public string DocumentName;
                
                // new with version 2.6: if enabled in organization settings, a seperate log per document can be downloaded
                public string LogDocIdPerDoc;                    

                // new with version 2.1: the values of the formfiels of a completed document
                public FormFields FormFieldValues;

                // new with version 3.0: list of attachments in a document
                public List<AttachmentInfo> Attachments;

                public class AttachmentInfo
                {
                    public string FileName;
                    public string DocumentId;

                    public static AttachmentInfo FromXmlElem(XmlElement attachmentElem)
                    {
                        AttachmentInfo attInfo = new AttachmentInfo();
                        attInfo.DocumentId = ((XmlElement)attachmentElem.SelectSingleNode("documentId")).InnerText;
                        attInfo.FileName = ((XmlElement)attachmentElem.SelectSingleNode("fileName")).InnerText;

                        return attInfo;
                    }
                }

                public static CompletedDocumentInfo FromXmlElement(XmlElement completedDocumentElem)
                {
                    CompletedDocumentInfo docInfo = new CompletedDocumentInfo();
                    docInfo.DocumentId = ((XmlElement)completedDocumentElem.SelectSingleNode("documentId")).InnerText;
                    docInfo.DocumentName = ((XmlElement)completedDocumentElem.SelectSingleNode("fileName")).InnerText;

                    XmlElement xmlElemLogDocId = (XmlElement)completedDocumentElem.SelectSingleNode("logDocumentId");
                    if (xmlElemLogDocId != null) {
                        docInfo.LogDocIdPerDoc = xmlElemLogDocId.InnerText;
                    }

                    //parse for form field values
                    docInfo.FormFieldValues = FormFields.FromXmlElement((XmlElement)completedDocumentElem.SelectSingleNode("fields"));
                   
                    XmlNodeList attachmentNodes = completedDocumentElem.SelectNodes("attachments/attachment");
                    if (attachmentNodes != null && attachmentNodes.Count > 0) {
                        docInfo.Attachments = new List<AttachmentInfo>();
                        foreach (XmlNode attachmentNode in attachmentNodes)
                        {
                               docInfo.Attachments.Add(AttachmentInfo.FromXmlElem((XmlElement)attachmentNode));
                        }
                    }

                    return docInfo;
                }
            }

        }


        /*
            <recipient>
                <orderIndex>1</orderIndex>
                <firstName>First</firstName>
				<lastName>Signer</lastName>
                <eMail>signer1@somewhere.com</eMail>
                <status>Signed</status>
                <signedDate>2016-04-06T15:26:55.863Z</signedDate>
                <recipientType>Signer</recipientType>
                <workstepRedirectionUrl>http://172.16.17.166/Flow/workstepredirector/sign?identifier=f01dc4b2-7700-4547-9a5a-f1249aee1be6</workstepRedirectionUrl>
                <workstepConfiguration> ... </workstepConfiguration>
         * 	    <authentication>
						<method>Sms</method>
						<parameter>+4366412345678</parameter>
				</authentication>
					<authentication>
						<method>Pin</method>
						<parameter>4812</parameter>
					</authentication>
            </recipient>
         */
        public class Recipient
        {

            public int OrderIndex;
            public string EMail;
            public string FirstName;
            public string LastName;
            public string Status;
            public DateTime SignedDate = DateTime.MaxValue;
            public string RecipientType;
            public string WorkstepRedirectionUrl;
            public XmlElement WorkstepConfiguration;
            public List<Authentication> Authentications;
            public string ID; 

            public static Recipient FromXmlElement(XmlElement recipientElem)
            {
                Recipient recip = new Recipient();
                recip.OrderIndex = XmlConvert.ToInt32(((XmlElement)recipientElem.SelectSingleNode("orderIndex")).InnerText);
                recip.ID = ((XmlElement)recipientElem.SelectSingleNode("id")).InnerText;
                recip.EMail = ((XmlElement)recipientElem.SelectSingleNode("eMail")).InnerText;
                recip.FirstName = ((XmlElement)recipientElem.SelectSingleNode("firstName")).InnerText;
                recip.LastName = ((XmlElement)recipientElem.SelectSingleNode("lastName")).InnerText;
                recip.Status = ((XmlElement)recipientElem.SelectSingleNode("status")).InnerText;
                recip.RecipientType = ((XmlElement)recipientElem.SelectSingleNode("recipientType")).InnerText;

                XmlElement workstepUrlElem = ((XmlElement)recipientElem.SelectSingleNode("workstepRedirectionUrl"));
                if (workstepUrlElem != null)
                {
                    recip.WorkstepRedirectionUrl = workstepUrlElem.InnerText;
                }

                recip.WorkstepConfiguration = (XmlElement)recipientElem.SelectSingleNode("workstepConfiguration");

                XmlElement signedDateElem = ((XmlElement)recipientElem.SelectSingleNode("signedDate"));
                if (signedDateElem != null && !String.IsNullOrWhiteSpace(signedDateElem.InnerText))
                {
                    recip.SignedDate = XmlConvert.ToDateTime(signedDateElem.InnerText, XmlDateTimeSerializationMode.Utc);
                }

                XmlNodeList authenticationNodeList = recipientElem.SelectNodes("authentication");
                if ( authenticationNodeList!= null && authenticationNodeList.Count > 0) {
                    recip.Authentications = new List<Authentication>();
                    foreach (XmlNode authNode in authenticationNodeList) {                     
                        recip.Authentications.Add(Authentication.FromXmlElement((XmlElement)authNode));                    
                    }                    
                }


                return recip;
            }

            public class Authentication {

                public string MethodName;
                public string Parameter;
                public List<Check> Checks;

                public static Authentication FromXmlElement(XmlElement authElem) { 
                   Authentication auth = new Authentication();

                   auth.MethodName = ((XmlElement)authElem.SelectSingleNode("method")).InnerText;
                   auth.Parameter = ((XmlElement)authElem.SelectSingleNode("parameter")).InnerText;

                    XmlNodeList checksNodeList = authElem.SelectNodes("checks/check");

                    if (checksNodeList != null && checksNodeList.Count > 0)
                    {
                       auth.Checks = new List<Check>();
                       foreach (XmlNode checkNode in checksNodeList)
                       {
                           auth.Checks.Add(Check.FromXmlElement((XmlElement)checkNode));
                       }                      
                   }

                   return auth;
                }

                public class Check {
                    public string CompareOperation;
                    public string FieldId;
                    public string Value;


                    public static Check FromXmlElement(XmlElement checkElem)
                    {
                        Check check = new Check();
                        check.Value = checkElem.GetAttribute("value");
                        check.FieldId = checkElem.GetAttribute("fieldId");
                        check.CompareOperation = checkElem.GetAttribute("compareOperation");

                        return check;
                    }
                }
            }

        }

 }
}
