﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;

namespace eeSignAnyWhere_SampleCode_SOAP
{
    class SignAnywhereFile
    {

        // <file><name>Demo_Contract_Form.pdf</name><data></data></file>

        public string FileName;
        public byte[] Data;

        public static SignAnywhereFile FromXmlElement(XmlElement fileXmlElem) {
            SignAnywhereFile file = new SignAnywhereFile();
            if (fileXmlElem != null)
            {
                file.FileName = fileXmlElem.SelectSingleNode("name").InnerText;
                file.Data = Convert.FromBase64String(fileXmlElem.SelectSingleNode("data").InnerText);
            }
            return file;
        }

        public string ToXml() {
            const string docXmlTemplate = "<file><data>##fileContent##</data><name>##filename##</name></file>";
            
            string docXml = docXmlTemplate.Replace("##filename##", this.FileName);
            docXml = docXml.Replace("##fileContent##", Convert.ToBase64String(this.Data));

            return docXml;
        }
    }
}
