﻿// Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace eSaw.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;

    /// <summary>
    /// The status of an envelope or bulk envelope.
    /// </summary>
    public partial class EnvelopeStatus
    {
        /// <summary>
        /// Initializes a new instance of the EnvelopeStatus class.
        /// </summary>
        public EnvelopeStatus() { }

        /// <summary>
        /// Initializes a new instance of the EnvelopeStatus class.
        /// </summary>
        public EnvelopeStatus(EnvelopeStatusEnum? status = default(EnvelopeStatusEnum?), DateTime? sendDate = default(DateTime?), DateTime? expirationDate = default(DateTime?), int? validityFromCreationInDays = default(int?), IList<EnvelopeBulkStatus> bulks = default(IList<EnvelopeBulkStatus>), IList<SentDocument> documents = default(IList<SentDocument>), string id = default(string), string bulk = default(string), EnvelopeBasicOptions basicOptions = default(EnvelopeBasicOptions))
        {
            Status = status;
            SendDate = sendDate;
            ExpirationDate = expirationDate;
            ValidityFromCreationInDays = validityFromCreationInDays;
            Bulks = bulks;
            Documents = documents;
            Id = id;
            Bulk = bulk;
            BasicOptions = basicOptions;
        }

        /// <summary>
        /// The overall status of the envelope or the bulk status in case of a
        /// bulk. Possible values include: 'Draft', 'Started', 'InProgress',
        /// 'Canceled', 'Completed', 'Expired', 'Rejected', 'Template',
        /// 'CompletedWithWarnings', 'BulkCompleted', 'BulkPartlyCompleted'
        /// </summary>
        [JsonProperty(PropertyName = "Status")]
        public EnvelopeStatusEnum? Status { get; set; }

        /// <summary>
        /// The date when the envelope was sent.
        /// </summary>
        [JsonProperty(PropertyName = "SendDate")]
        public DateTime? SendDate { get; set; }

        /// <summary>
        /// The date when the envelope will expire.
        /// </summary>
        [JsonProperty(PropertyName = "ExpirationDate")]
        public DateTime? ExpirationDate { get; set; }

        /// <summary>
        /// The number of days from when the envelope will expire, starting
        /// from the send date.
        /// </summary>
        [JsonProperty(PropertyName = "ValidityFromCreationInDays")]
        public int? ValidityFromCreationInDays { get; set; }

        /// <summary>
        /// The list of envelopes which belong to the bulk envelope in case of
        /// a bulk.
        /// In case of a non bulk envelope it consists only of 1 envelope -
        /// the actual envelope.
        /// </summary>
        [JsonProperty(PropertyName = "Bulks")]
        public IList<EnvelopeBulkStatus> Bulks { get; set; }

        /// <summary>
        /// The documents which belong to the envelope.
        /// </summary>
        [JsonProperty(PropertyName = "Documents")]
        public IList<SentDocument> Documents { get; set; }

        /// <summary>
        /// The id of the envelope.
        /// </summary>
        [JsonProperty(PropertyName = "Id")]
        public string Id { get; set; }

        /// <summary>
        /// The bulk id of the envelope. If the envelope is not a bulk, this
        /// value is empty.
        /// </summary>
        [JsonProperty(PropertyName = "Bulk")]
        public string Bulk { get; set; }

        /// <summary>
        /// Properties of the envelope (e.g. reminder settings).
        /// </summary>
        [JsonProperty(PropertyName = "BasicOptions")]
        public EnvelopeBasicOptions BasicOptions { get; set; }

    }
}
