﻿// Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace eSaw.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;

    /// <summary>
    /// A step in an envelope representing recipients.
    /// </summary>
    public partial class SendEnvelopeStep
    {
        /// <summary>
        /// Initializes a new instance of the SendEnvelopeStep class.
        /// </summary>
        public SendEnvelopeStep() { }

        /// <summary>
        /// Initializes a new instance of the SendEnvelopeStep class.
        /// </summary>
        public SendEnvelopeStep(int? orderIndex = default(int?), IList<SendEnvelopeRecipient> recipients = default(IList<SendEnvelopeRecipient>), string emailBodyExtra = default(string), RecipientTypeEnum? recipientType = default(RecipientTypeEnum?), WorkstepConfiguration workstepConfiguration = default(WorkstepConfiguration), IList<SendEnvelopeDocumentOption> documentOptions = default(IList<SendEnvelopeDocumentOption>), bool? useDefaultAgreements = default(bool?))
        {
            OrderIndex = orderIndex;
            Recipients = recipients;
            EmailBodyExtra = emailBodyExtra;
            RecipientType = recipientType;
            WorkstepConfiguration = workstepConfiguration;
            DocumentOptions = documentOptions;
            UseDefaultAgreements = useDefaultAgreements;
        }

        /// <summary>
        /// The order index of the step.
        /// </summary>
        [JsonProperty(PropertyName = "OrderIndex")]
        public int? OrderIndex { get; set; }

        /// <summary>
        /// A list of recipients for this step (usally 1, multiple for bulk).
        /// Not necessary in case of &lt;code&gt;RecipientType&lt;/code&gt;
        /// Automatic
        /// </summary>
        [JsonProperty(PropertyName = "Recipients")]
        public IList<SendEnvelopeRecipient> Recipients { get; set; }

        /// <summary>
        /// The additional email body for the step.
        /// </summary>
        [JsonProperty(PropertyName = "EmailBodyExtra")]
        public string EmailBodyExtra { get; set; }

        /// <summary>
        /// The recipient type of the step. Possible values include: 'Signer',
        /// 'Cc', 'Acknowledge', 'Pkcs7Signer', 'Automatic'
        /// </summary>
        [JsonProperty(PropertyName = "RecipientType")]
        public RecipientTypeEnum? RecipientType { get; set; }

        /// <summary>
        /// The configuration for the step.
        /// Only necessary for &lt;code&gt;RecipientType&lt;/code&gt; Signer
        /// and Pkcs7Signer.
        /// </summary>
        [JsonProperty(PropertyName = "WorkstepConfiguration")]
        public WorkstepConfiguration WorkstepConfiguration { get; set; }

        /// <summary>
        /// The document options for the step.
        /// </summary>
        [JsonProperty(PropertyName = "DocumentOptions")]
        public IList<SendEnvelopeDocumentOption> DocumentOptions { get; set; }

        /// <summary>
        /// Use default Agreements from SignatureDisclosure settings
        /// </summary>
        [JsonProperty(PropertyName = "UseDefaultAgreements")]
        public bool? UseDefaultAgreements { get; set; }

    }
}
