﻿// Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace eSaw.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;

    /// <summary>
    /// TypeWriterAnnotation task. Information about predefined typewriter
    /// annotation.
    /// </summary>
    public partial class TypewriterAnnotation : WorkstepTask
    {
        /// <summary>
        /// Initializes a new instance of the TypewriterAnnotation class.
        /// </summary>
        public TypewriterAnnotation() { }

        /// <summary>
        /// Initializes a new instance of the TypewriterAnnotation class.
        /// </summary>
        public TypewriterAnnotation(bool? isRequired = default(bool?), string id = default(string), string displayName = default(string), int? docRefNumber = default(int?), string additionalInformation = default(string), string batchId = default(string), int? pageNumber = default(int?), Align? textAlign = default(Align?), Position position = default(Position), string defaultText = default(string), string textFormat = default(string), string defaultTextType = default(string), FontSettings fontSettings = default(FontSettings), bool? isEditablePosition = default(bool?), bool? isEditableDefaultText = default(bool?), bool? isEditableFontSettings = default(bool?))
            : base(isRequired, id, displayName, docRefNumber, additionalInformation, batchId)
        {
            PageNumber = pageNumber;
            TextAlign = textAlign;
            Position = position;
            DefaultText = defaultText;
            TextFormat = textFormat;
            DefaultTextType = defaultTextType;
            FontSettings = fontSettings;
            IsEditablePosition = isEditablePosition;
            IsEditableDefaultText = isEditableDefaultText;
            IsEditableFontSettings = isEditableFontSettings;
        }

        /// <summary>
        /// The page number the annotation is on.
        /// </summary>
        [JsonProperty(PropertyName = "PageNumber")]
        public int? PageNumber { get; set; }

        /// <summary>
        /// The typewriter annotation text alignment. Possible values include:
        /// 'Left', 'Right', 'Center'
        /// </summary>
        [JsonProperty(PropertyName = "TextAlign")]
        public Align? TextAlign { get; set; }

        /// <summary>
        /// The position of the predefined text annotation in lower left
        /// points.
        /// </summary>
        [JsonProperty(PropertyName = "Position")]
        public Position Position { get; set; }

        /// <summary>
        /// Default text shown by the client.
        /// </summary>
        [JsonProperty(PropertyName = "DefaultText")]
        public string DefaultText { get; set; }

        /// <summary>
        /// The format of the text. For example if the text should be a date,
        /// the date format can be specified. The client can than format the
        /// text accordingly.
        /// </summary>
        [JsonProperty(PropertyName = "TextFormat")]
        public string TextFormat { get; set; }

        /// <summary>
        /// The type of the predefined text annotation. If the client is
        /// familiar with the type it can display predefined values.
        /// </summary>
        [JsonProperty(PropertyName = "DefaultTextType")]
        public string DefaultTextType { get; set; }

        /// <summary>
        /// FontSetting to be used.
        /// </summary>
        [JsonProperty(PropertyName = "FontSettings")]
        public FontSettings FontSettings { get; set; }

        /// <summary>
        /// Defines if the position can be edited by the client.
        /// </summary>
        [JsonProperty(PropertyName = "IsEditablePosition")]
        public bool? IsEditablePosition { get; set; }

        /// <summary>
        /// Specifies if the text can be changed by the user, or if it should
        /// be autofilled by the client without user interaction.
        /// </summary>
        [JsonProperty(PropertyName = "IsEditableDefaultText")]
        public bool? IsEditableDefaultText { get; set; }

        /// <summary>
        /// Defines if the 'fontSettings' can be edited by the client.
        /// </summary>
        [JsonProperty(PropertyName = "IsEditableFontSettings")]
        public bool? IsEditableFontSettings { get; set; }

    }
}
