﻿// Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace eSaw.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;

    /// <summary>
    /// The workstep configuration used to create the workstep.
    /// </summary>
    public partial class WorkstepConfiguration
    {
        /// <summary>
        /// Initializes a new instance of the WorkstepConfiguration class.
        /// </summary>
        public WorkstepConfiguration() { }

        /// <summary>
        /// Initializes a new instance of the WorkstepConfiguration class.
        /// </summary>
        public WorkstepConfiguration(string workstepLabel = default(string), int? smallTextZoomFactorPercent = default(int?), FinishAction finishAction = default(FinishAction), IntroTexts introTexts = default(IntroTexts), ReceiverInformation receiverInformation = default(ReceiverInformation), SenderInformation senderInformation = default(SenderInformation), IList<TransactionCodeConfiguration> transactionCodeConfigurations = default(IList<TransactionCodeConfiguration>), IList<SignatureConfiguration> signatureConfigurations = default(IList<SignatureConfiguration>), ViewerPreferences viewerPreferences = default(ViewerPreferences), ResourceUris resourceUris = default(ResourceUris), AuthenticationMethods authenticationMethods = default(AuthenticationMethods), string additionalClientWorkstepInformation = default(string), AuditingToolsConfiguration auditingToolsConfiguration = default(AuditingToolsConfiguration), Policy policy = default(Policy))
        {
            WorkstepLabel = workstepLabel;
            SmallTextZoomFactorPercent = smallTextZoomFactorPercent;
            FinishAction = finishAction;
            IntroTexts = introTexts;
            ReceiverInformation = receiverInformation;
            SenderInformation = senderInformation;
            TransactionCodeConfigurations = transactionCodeConfigurations;
            SignatureConfigurations = signatureConfigurations;
            ViewerPreferences = viewerPreferences;
            ResourceUris = resourceUris;
            AuthenticationMethods = authenticationMethods;
            AdditionalClientWorkstepInformation = additionalClientWorkstepInformation;
            AuditingToolsConfiguration = auditingToolsConfiguration;
            Policy = policy;
        }

        /// <summary>
        /// A label for this workstep.
        /// </summary>
        [JsonProperty(PropertyName = "WorkstepLabel")]
        public string WorkstepLabel { get; set; }

        /// <summary>
        /// Defines a image generation correction factor. If for example this
        /// document contains very small text, which might not be readable
        /// with the standard image resolution of the client, this factor can
        /// be used to tell the client to get a higher resolution.
        /// </summary>
        [JsonProperty(PropertyName = "SmallTextZoomFactorPercent")]
        public int? SmallTextZoomFactorPercent { get; set; }

        /// <summary>
        /// Configure the actions done by the server and the by the clients
        /// when the workstep is finished.
        /// </summary>
        [JsonProperty(PropertyName = "FinishAction")]
        public FinishAction FinishAction { get; set; }

        /// <summary>
        /// Intro texts.
        /// </summary>
        [JsonProperty(PropertyName = "IntroTexts")]
        public IntroTexts IntroTexts { get; set; }

        /// <summary>
        /// Information about the recipient of the document.
        /// </summary>
        [JsonProperty(PropertyName = "ReceiverInformation")]
        public ReceiverInformation ReceiverInformation { get; private set; }

        /// <summary>
        /// Information about the sender of the document.
        /// </summary>
        [JsonProperty(PropertyName = "SenderInformation")]
        public SenderInformation SenderInformation { get; private set; }

        /// <summary>
        /// Collection of TransactionCodeConfigurations
        /// </summary>
        [JsonProperty(PropertyName = "TransactionCodeConfigurations")]
        public IList<TransactionCodeConfiguration> TransactionCodeConfigurations { get; set; }

        /// <summary>
        /// Collection of SignatureConfigurations
        /// </summary>
        [JsonProperty(PropertyName = "SignatureConfigurations")]
        public IList<SignatureConfiguration> SignatureConfigurations { get; set; }

        /// <summary>
        /// The Viewer Preferences can be used to adapt the appearance and the
        /// behavior of the SignAnyWhere Viewer.
        /// </summary>
        [JsonProperty(PropertyName = "ViewerPreferences")]
        public ViewerPreferences ViewerPreferences { get; set; }

        /// <summary>
        /// Rescource uris.
        /// </summary>
        [JsonProperty(PropertyName = "ResourceUris")]
        public ResourceUris ResourceUris { get; private set; }

        /// <summary>
        /// Authentication methods.
        /// </summary>
        [JsonProperty(PropertyName = "AuthenticationMethods")]
        public AuthenticationMethods AuthenticationMethods { get; private set; }

        /// <summary>
        /// Additional client workstep information.
        /// </summary>
        [JsonProperty(PropertyName = "AdditionalClientWorkstepInformation")]
        public string AdditionalClientWorkstepInformation { get; private set; }

        /// <summary>
        /// Configuration regarding tools for auditing.
        /// </summary>
        [JsonProperty(PropertyName = "AuditingToolsConfiguration")]
        public AuditingToolsConfiguration AuditingToolsConfiguration { get; private set; }

        /// <summary>
        /// Workstep policies.
        /// </summary>
        [JsonProperty(PropertyName = "Policy")]
        public Policy Policy { get; set; }

    }
}
